<?php

function engagebay_wc_created_customer($customer_id, $new_customer_data, $password_generated)
{
    $contact = array(
                    'first_name' => $new_customer_data['user_login'],
                    'last_name' => '',
                    'email' => $new_customer_data['user_email'],
                    'phone' => '',
                    'address' => '',
                    'company_name' => '',
                    'role' => $new_customer_data['role'],
                    );
    engagebay_wc_sync_contact($contact);
}

function engagebay_wc_new_order($order_id)
{
}

function engagebay_wc_order_processed($order_id, $posted_data, $order)
{
    $order_data = $order->data;

    $customer_id = $order_data['customer_id'];
    $customer = new WC_Customer($customer_id);
    $customer_data = $customer->get_data();

    $customer_email = $customer_data['email'];
    if ($customer_email == '' || $customer_email == null) {
        $customer_email = $order_data['billing']['email'];
        $customer_first_name = $order_data['billing']['first_name'];
        $customer_last_name = $order_data['billing']['last_name'];
        $customer_phone = $order_data['billing']['phone'];
        $customer_company = $order_data['billing']['company'];
    } else {
        $customer_email = $customer_data['email'];
        $customer_first_name = $customer_data['first_name'];
        $customer_last_name = $customer_data['last_name'];
        $customer_phone = $customer_data['billing']['phone'];
        $customer_company = $customer_data['billing']['company'];
    }

    $order_id = $order_data['id'];
    $subject = 'Order #'.$order_id.' has been created';
    $line_items = $order->data['line_items'];
    $items = array();
    foreach ($line_items as $item) {
        $item_name = $item['name'];
        array_push($items, $item_name);
    }

    $all_items = implode(',', $items);

    $billing_address = $order_data['billing']['address_1'].','.$order_data['billing']['city'].','.$order_data['billing']['state'].'-'.$order_data['billing']['postcode'].','.$order_data['billing']['country'].','.$order_data['billing']['phone'];
    $billing_email = $order_data['billing']['email'];
    $content = 'Products: '.$all_items.'  ';
    //$content .= "<br/>";
    $content .= 'Total: '.$order_data['total'].'  ';
    //$content .= "<br/>";
    $content .= 'Billing: '.$billing_address;

    $orderdata = array('order_id' => $order_id, 'subject' => $subject, 'content' => $content, 'billing_email' => $billing_email, 'customer_email' => $customer_email, 'products' => $all_items);

    $customer_address = array(
        'address' => (empty($order_data['billing']['address_2'])) ? $order_data['billing']['address_1'] : $order_data['billing']['address_1'].' '.$order_data['billing']['address_2'],
        'city' => $order_data['billing']['city'],
        'state' => WC()->countries->states[$order_data['billing']['country']][$order_data['billing']['state']],
        'zip' => $order_data['billing']['postcode'],
        'country' => WC()->countries->countries[$order_data['billing']['country']],
    );

    $contact = array(
                'first_name' => $customer_first_name,
                'last_name' => $customer_last_name,
                'email' => $customer_email,
                'phone' => $customer_phone,
                'company_name' => $customer_company,
                'address' => json_encode($customer_address),
                'role' => $customer_data['role'],
                );

    engagebay_wc_sync_contact($contact);
    engagebay_sync_order_details($orderdata);
}

function engagebay_wc_updated_customer($customer, $updated_properties)
{
    $customer_data = $customer->get_data();

    $customer_address = array(
        'address' => (empty($customer_data['billing']['address_2'])) ? $customer_data['billing']['address_1'] : $customer_data['billing']['address_1'].','.$customer_data['billing']['address_2'],
        'city' => $customer_data['billing']['city'],
        'state' => !empty($customer_data['billing']['country']) ? WC()->countries->states[$customer_data['billing']['country']][$customer_data['billing']['state']] : '',
        'zip' => $customer_data['billing']['postcode'],
        'country' => !empty($customer_data['billing']['country']) ? $customer_data['billing']['country'] : '',
    );
    $contact = array(
        'first_name' => $customer_data['first_name'],
        'last_name' => $customer_data['last_name'],
        'email' => $customer_data['email'],
        'phone' => $customer_data['billing']['phone'],
        'company_name' => $customer_data['billing']['company'],
        'address' => json_encode($customer_address),
        'role' => $customer_data['role'],
        );
    engagebay_wc_sync_contact($contact);
}

function engagebay_wc_script()
{
    $script = "<script type=\"text/javascript\" >
                var EhAPI = EhAPI || {}; EhAPI.after_load = function(){
                EhAPI.set_account('".get_option('engagebay_wc_settings_js_api')."', '".get_option('engagebay_wc_settings_domain')."');
                EhAPI.execute('rules');};(function(d,s,f) {
                var sc=document.createElement(s);sc.type='text/javascript';
                sc.async=true;sc.src=f;var m=document.getElementsByTagName(s)[0];
                m.parentNode.insertBefore(sc,m);   
                })(document, 'script', '//d2p078bqz5urf7.cloudfront.net/jsapi/ehform.js');
                </script> ";

    echo $script;
}

function engagebay_wc_sync_users($users)
{
    $users_count = count($users);
    $batch_count = 100;
    $user_chunks = $users_count / $batch_count;
    $divides_zero = $users_count % $batch_count;

    if ($divides_zero != 0) {
        $user_chunks = (int) $user_chunks + 1;
    }

    for ($j = 1; $j <= $user_chunks; ++$j) {
        $batches[$j] = [];
    }    

    for ($i = 0; $i < $users_count; ++$i) {
        for ($j = 1; $j <= $user_chunks; ++$j) {
            if ($i < $j * $batch_count) {
                $user_email = $users[$i]->data->user_email;
                $customer = new WC_Customer($users[$i]->id);                
                $customer_data = $customer->get_data();                     
                $customer_address = array(
                                    'address' => (empty($customer_data['billing']['address_2'])) ? $customer_data['billing']['address_1'] : $customer_data['billing']['address_1'].' '.$customer_data['billing']['address_2'],
                                    'city' => $customer_data['billing']['city'],
                                    'state' => WC()->countries->states[$customer_data['billing']['country']][$customer_data['billing']['state']],
                                    'zip' => $customer_data['billing']['postcode'],
                                    'country' => $customer_data['billing']['country'],
                                );

                $contact = array(
                        'first_name' => empty($customer_data['first_name']) ? $customer_data['display_name'] : $customer_data['first_name'],
                        'last_name' => $customer_data['last_name'],
                        'email' => $user_email,
                        'phone' => '',
                        'address' => json_encode($customer_address),
                        'roles' => implode(',', $users[$i]->roles).','.enagagebay_wc_woocommerce_domain(),
                        );
                array_push($batches[$j], $contact);
                break;
            }
        }
    }

    foreach ($batches as $batch) {
        engagebay_wc_endpoint($batch, 'CONTACT');
    }
}

function engagebay_wc_sync_orders($orders)
{
    $orders_count = count($orders);
    $batch_count = 100;
    $order_chunks = $orders_count / $batch_count;
    $divides_zero = $orders_count % $batch_count;

    if ($divides_zero != 0) {
        $order_chunks = (int) $order_chunks + 1;
    }

    for ($j = 1; $j <= $order_chunks; ++$j) {
        $batches[$j] = [];
    }

    for ($i = 0; $i < $orders_count; ++$i) {
        for ($j = 1; $j <= $order_chunks; ++$j) {
            if ($i < $j * $batch_count) {
                $order_data = wc_get_order($orders[$i])->get_data();
                $order_id = $order_data['id'];

                $customer_id = $order_data['customer_id'];
                $customer = new WC_Customer($customer_id);
                $customer_data = $customer->get_data();
                $customer_email = $customer_data['email'];

                $subject = 'Order #'.$order_id.' has been created';
                $line_items = $order_data['line_items'];
                $items = array();
                foreach ($line_items as $item) {
                    $item_name = $item['name'];
                    array_push($items, $item_name);
                }

                $all_items = implode(',', $items);
                // if (!isset($order_data['billing'])) {
                //     continue;
                // }
                $billing_address = $order_data['billing']['address_1'].','.$order_data['billing']['city'].','.$order_data['billing']['state'].'-'.$order_data['billing']['postcode'].','.$order_data['billing']['country'].','.$order_data['billing']['phone'];
                $billing_email = $order_data['billing']['email'];
                $content = 'Order Status: '.$order_data['status'].'  ';
                $content = 'Products: '.$all_items.'  ';
                //$content .= "<br/>";
                $content .= 'Total: '.$order_data['total'].'  ';
                //$content .= "<br/>";
                $content .= 'Billing: '.$billing_address;

                $customer_address = array(
                                            'address' => (empty($customer_data['billing']['address_2'])) ? $customer_data['billing']['address_1'] : $customer_data['billing']['address_1'].' '.$customer_data['billing']['address_2'],
                                            'city' => $customer_data['billing']['city'],
                                            'state' => WC()->countries->states[$customer_data['billing']['country']][$customer_data['billing']['state']],
                                            'zip' => $customer_data['billing']['postcode'],
                                            'country' => $customer_data['billing']['country'],
                                        );

                $contact = array(
                    'first_name' => $customer_data['first_name'],
                    'last_name' => $customer_data['last_name'],
                    'email' => $customer_email,
                    'phone' => $customer_data['billing']['phone'],
                    'company_name' => $customer_data['billing']['company'],
                    'address' => json_encode($customer_address),
                    'roles' => $customer_data['role'].','.enagagebay_wc_woocommerce_domain(),
                    );

                //if ($customer_email != '' || $customer_email != null) {
                // engagebay_wc_sync_contact($contact);
                $orderdata = array('order_id' => $order_id, 'subject' => $subject, 'content' => $content, 'customer_email' => $customer_email, 'billing_email' => $billing_email, 'products' => $all_items);
                // engagebay_sync_order_details($orderdata);

                $completeData['contact_details'] = $contact;
                $completeData['order_details'] = $orderdata;
                array_push($batches[$j], $completeData);
                break;
                //}
            }
        }
    }

    foreach ($batches as $batch) {
        engagebay_wc_endpoint($batch, 'ORDERS');
    }
}

function enagagebay_wc_woocommerce_domain()
{
    $sURL = site_url(); // WordPress function
    $asParts = parse_url($sURL); // PHP function

    if (!$asParts) {
        return '';
    }

    $host = $asParts['host'];
    $split_hosts = explode('.', $host);

    return $split_hosts[0];
}
